/*------------------------------------------------------------------
AVR-Studio-4.18: test_isp_display.aps 

Programmpaket zum Ansprechen von Modul 2 - 7Seg.Display:

test_isp_display.c, twi_driver.c , test_isp_display.h					
(test_display.hex)

Demo-Test-Programm:

	+Anzeige 8.8.8.8.
	+Anzeige 01.23
	+Zhler 0-200 endlos
	+LED auf PD7 - Blinker, nur auf Testboard

Hardware: isp-testboard.pcb , Modul 3 , Modul 2
Quarz: f = 16 MHz 
Autor:bay	 Datum: 06.10.09

gendert:23.12.09
27.01.10 AVRSt4.18   	ok
-------------------------------------------------------------------*/
#include <avr/io.h>
#include <C:\WinAVR-20100110\avr\include\compat\twi.h>	//home
#include "test_isp_display.h"

uchar bcd[8] = {0x00};	//entpackte(einzelne) BCD-Daten

uchar bin[8] = {0x00};	// Daten im Binrcode

uchar tab_7seg[10]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x67};
                        // Siebensegment- Codetabelle fr SAA1064 
//Anzeigebuffer
uchar data_1064[8];	//0 bis 3 Daten:LD1 - LD4 ,  4 - 7 Controlbytes
			
//*********Wartefunktion***************
void wait_ms(uint msec)    	// 	Warteschleife ca. Anzahl Millisek. 
{														// 	bei 16 MHz 
	uchar i,j;
	for (;msec!=0;msec--)
         for(i=0;i<87;i++)
            for(j=0;j<15;j++);
}

//***************Codewandler BCD - 7 Segment fuer 1064*****************************

void bcd_7seg(uchar ld1)
{
  uchar i,j; 

  	for (i=ld1,j=0;j<4;i++,j++)
		{
  	 	data_1064[j] = tab_7seg[bcd[i]];
			data_1064[1] |= 0x80; 	//DP LD2 ein			
		} 
}
//***************Codewandler 1 Byte Binr nach BCD - 3stellig*************

void bin1_bcd3(uchar bin_quelle,uchar bcd_ziel_e)	
{
	uchar zahl;	
	
	zahl = bin[bin_quelle];
	bcd[bcd_ziel_e] = zahl % 10;				// Einer
	zahl /= 10;				
	bcd[bcd_ziel_e - 1] = zahl % 10;		// Zehner
	zahl /= 10;				
	bcd[bcd_ziel_e - 2] = zahl % 10;		// Hunderter
}

//****************************************************											
int main (void)  
{
	//Init. TWI ************************************	
	TWBR = 20; 
	TWSR = (1<<TWPS0); //f SCL = 90909 Hz 

	DDRD |= (1<<PD7);// LED-Zustandanzeige

	PORTC |= (1<<PC4) | (1<<PC5); //interne Pull-Up Widerst. akt.
	
	//Init. SAA1064************************************
	data_1064[4] = 0x67;	//Controlbyte alle Digits ein, 18 mA
	data_1064[5] = 0x71;	//Controlbyte alle Digits aus
	data_1064[6] = 0x63;	//Controlbyte  Anzeige LD1 + LD3, 18 mA
	data_1064[7] = 0x75;	//Controlbyte  Anzeige LD2 + LD4
	m_t(SAA1064_0, 0, 1, data_1064,4);	

	//Anzeige 8.8.8.8.
	data_1064[0] = data_1064[1] = data_1064[2] = data_1064[3]=0xff;			
	m_t(SAA1064_0, 1, 4, data_1064,0);	//Daten anzeigen
	wait_ms(6000);

	//Anzeige ----
	data_1064[0] = data_1064[1] = data_1064[2] = data_1064[3]=0x40;			
	m_t(SAA1064_0, 1, 4, data_1064,0);	//Daten anzeigen
	wait_ms(1000);

	//Anzeige 01.23
	bcd[0] = 0;
	bcd[1] = 1;
	bcd[2] = 2;
	bcd[3] = 3;
	bcd_7seg(0);	//Daten wandeln
	m_t(SAA1064_0, 1, 4, data_1064,0);//Daten anzeigen
	wait_ms(1000);

	for(;;)	
	{
		if(++bin[0] == 201)	//Zhler 0 bis 200
			bin[0] = 0;			
		bin1_bcd3(0,3);
		bcd_7seg(0);
		m_t(SAA1064_0, 1, 4, data_1064,0); //Daten anzeigen
		PORTD |= 1<<PD7;	//LED ein				
		wait_ms(50);
		PORTD &= ~(1<<PD7); //LED aus
		wait_ms(50);
	}















}
