	//Headerdatei ukt.h fr alle ukt-Projekte
	//nderungen:
	//5.3. Jahresrohwerte
	//8.3. Summerflag
	//***************************************

	#define uchar unsigned char
	#define uint unsigned int

	//TWI Status Codes
	#define start 0x08				//Start
	#define restart 0x10			//Restart

	#define mt_sla_ack 0x18 	// SLA+W gesendet , A empfangen
	#define mt_data_ack 0x28 	// Data gesendet , A empfangen

	#define mr_data_nack 0x58	// Data empfangen , NACK gesendet
	#define mr_data_ack 0x50	// Data empfangen , ACK gesendet
	#define mr_sla_ack 0x40 	// SLA+R gesendet , A empfangen

	// TWI Slave Auswahl-Nummern
	#define PCF8574_0 0				
	#define PCF8574_1 1
	#define SAA1064_0 2
	#define PCF8583_0 3
	#define MCP9801_0 4

	// Adressen der IIC - Bus- Teilnehmer 
	#define w_adr_1064_0 0x70    /* Schreibadr. f. SAA1064 mit Subadr. 0 */
	#define r_adr_8583_0 0xA1    /* Leseadr. f. 8583 mit Subadr. 0    */
	#define w_adr_8583_0 0xA0    /* Schreibadr. f. 8583 mit Subadr. 0 */
	#define w_adr_8574_0 0x40    /* Schreibadr. f. 8574 mit Subadr. 0 */
	#define r_adr_8574_0 0x41    /* Leseadr. f. 8574 mit Subadr. 0    */
	#define w_adr_9801_0 0x90    /* Schreibadr. f. Temp.Sensor 				*/
	#define r_adr_9801_0 0x91    /* Leseadr. f. Temp.Sensor		    		*/

	// Prototypen
	uchar m_t(uchar slave, uchar startadr, signed char len, uchar *buf,uchar buf_offset);
	uchar m_r(uchar slave, uchar startaddr, signed char len, uchar *buf,uchar buf_offset);
	void bcd_7seg(uchar ld1);
	void entpacke(uchar wahl);
	void day_count_calc(void);
	void bin1_bcd2(uchar von,uchar bis);
	void bcd2_bin1(void);
	void wait_ms(uint);
	void set_8583_uk(void);
	void disp_on_off(uchar wahl);
	uchar tasten(void);
	uchar not_leap(void);
	void set_8583_alarm(void);
	void bin1_bcd3(uchar bin_quelle,uchar bcd_ziel_e);
	void kw_calc(void);
	void temp(void);
	void line(uchar art);
	void ir_control(void);
	void stoppuhr(void);
	void summer(uchar piepszahl);

	//Positionen fr Daten in bcd_8583[]

	#define control_status	0
	#define hundredths      1
	#define secounds 				2
	#define minutes 				3
	#define hours 					4
	#define year_date				5
	#define weekday_month		6
	#define timer						7

	#define alarm_control		8
	#define a_hundredths    9
	#define a_secounds			10
	#define a_minutes 			11
	#define a_hours   			12
	#define a_date    			13
	#define a_month					14
	#define a_timer					15

	//Positionen fr Daten in bcd[]

	#define zhour 			0
	#define ehour 			1
	#define zmin  			2
	#define emin  			3
	#define zsec  			4
	#define esec  			5
	#define zday  			6
	#define eday  			7	
	#define zmonth  		8
	#define emonth  		9
	#define tyear  			10
	#define hyear  			11
	#define zyear  			12
	#define eyear  			13
	#define weekday  		14
	#define hday_count  15
	#define zday_count  16
	#define eday_count  17
	#define htest			  18
	#define ztest			  19
	#define etest			  20
	#define zkw 			  21
	#define ekw 			  22
	#define ztemp 			23
	#define etemp			  24
	#define y8583act    25	//yy00 0000 aktueller Jahresrohwert aus 8583 year_date
	#define y8583old    26	//yy00 0000 alter Jahresrohwert aus 8583 18


	//Positionen fr Daten in bin[]

	#define hour 			0
	#define min  			1
	#define sec  			2
	#define day  			3
	#define month 		4
	#define year_z_e	5
	#define test 			6	
	#define kw	 			7
	#define wochentag1jan	8
	#define msb_9801					9
	#define config_9801 			10
	#define go_oneshot_9801 	11

	//Positionen der Flags im Register flag_reg

	#define sec_flag 			0
	#define min_flag 			1
	#define day_flag 			2
	#define alarm_flag		3
	#define set_slow_flag 4
	#define set_fast_flag 5
	#define stoppuhr_flag 6
	#define summer_flag   7












